#ifndef THRILLE_UPC_H
#define THRILLE_UPC_H

//#define SRC_ARGS    const char*, unsigned int, const char*
#define SRC_ARGS    const char*

#define QUOTEME_(x) #x
#define QUOTEME(x)  QUOTEME_(x)
#define SIG(f,l,e)    (f ":" l ":" e)
#define SIGFLE(expr)   (SIG(__FILE__,QUOTEME(__LINE__),#expr)) 


#define THRILLE_DECLS(PASS_NAME) \
extern void thrille_before_read_ ## PASS_NAME(int,uint64_t,SRC_ARGS,int,int);\
extern void thrille_after_read_ ## PASS_NAME(int,uint64_t,SRC_ARGS,int,int);\
extern uintmax_t thrille_after_read_reg_ ## PASS_NAME(int,uint64_t,SRC_ARGS,uintmax_t,int,int);\
extern float thrille_after_read_float_ ## PASS_NAME(int,uint64_t,SRC_ARGS,float,int,int);\
extern double thrille_after_read_double_ ## PASS_NAME(int,uint64_t,SRC_ARGS,double,int,int);\
extern void thrille_before_write_ ## PASS_NAME(int,uint64_t,SRC_ARGS,int,int);\
extern void thrille_after_write_ ## PASS_NAME(int,uint64_t,SRC_ARGS,int,int);\
extern void thrille_before_lock_ ## PASS_NAME(int, uint64_t, SRC_ARGS);\
extern void thrille_after_lock_ ## PASS_NAME(int, uint64_t, SRC_ARGS);\
extern void thrille_before_unlock_ ## PASS_NAME(int, uint64_t, SRC_ARGS);\
extern void thrille_after_unlock_ ## PASS_NAME(int, uint64_t, SRC_ARGS);\
extern void thrille_before_lock_attempt_ ## PASS_NAME(int, uint64_t, SRC_ARGS);\
extern int  thrille_after_lock_attempt_ ## PASS_NAME(int, uint64_t, SRC_ARGS, int);\
extern void thrille_before_notify_ ## PASS_NAME(int, int, SRC_ARGS);\
extern void thrille_after_notify_ ## PASS_NAME(int, int, SRC_ARGS);\
extern void thrille_before_wait_ ## PASS_NAME(int, int, SRC_ARGS);\
extern void thrille_after_wait_ ## PASS_NAME(int, int, SRC_ARGS);\
extern void thrille_before_try_wait_ ## PASS_NAME(int, int, SRC_ARGS);\
extern int  thrille_after_try_wait_ ## PASS_NAME(int, int, SRC_ARGS, int);\


#if defined(UPCR_THRILLE_RACER)
    THRILLE_DECLS(racer)
#define THRILLE_BEFORE(function,_expr,pass,extra...)  thrille_before_ ## function ## _racer\
        (upcr_mythread(), _expr, SIGFLE(_expr) , ## extra)
#define THRILLE_AFTER(function,_expr,pass,extra...)   thrille_after_ ## function ## _racer\
        (upcr_mythread(), _expr, SIGFLE(_expr) , ## extra)
#define THRILLE_AFTER_RET(function,_expr,pass,_retarg,extra...) thrille_after_ ## function ## _racer\
        (upcr_mythread(), _expr, SIGFLE(_expr), _retarg , ## extra)
#elif defined(UPCR_THRILLE_TESTER)
    THRILLE_DECLS(tester)
#define THRILLE_BEFORE(function,_expr,pass,extra...)  thrille_before_ ## function ## _tester\
        (upcr_mythread(), _expr, SIGFLE(_expr) , ## extra)
#define THRILLE_AFTER(function,_expr,pass,extra...)   thrille_after_ ## function ## _tester\
        (upcr_mythread(), _expr, SIGFLE(_expr) , ## extra)
#define THRILLE_AFTER_RET(function,_expr,pass,_retarg,extra...) thrille_after_ ## function ## _tester\
        (upcr_mythread(), _expr, SIGFLE(_expr), _retarg , ## extra)
#else
    #define THRILLE_BEFORE(function,_expr,pass,extra...)    (0)
    #define THRILLE_AFTER(function,_expr,pass,extra...)     (0)
    #define THRILLE_AFTER_RET(function,_expr,pass,_retarg,extra...) (_retarg)
#endif


#if 0
#define THRILLE_BEFORE_READ(_addr)  thrille_before_read(MYTHREAD, (long)_addr, __FILE__, __LINE__, #_addr) 
#define THRILLE_BEFORE_WRITE(_addr) thrille_before_write(MYTHREAD, (long)_addr, __FILE__, __LINE__, #_addr) 
#endif


#endif

