/*
 * access.h
 *
 *  Created on: Nov 8, 2010
 *      Author: parkcs
 */

#ifndef ACCESS_H_
#define ACCESS_H_

#include "intervals/interval.h"

typedef enum _AccessType {
    READ,
    WRITE
} AccessType;

#define MULTIPLE_THREADS	-1

/*	Late will become race_data_t
typedef struct access_info_min_t {
//    int    size;
    mem_range   addr;
    enum _AccessType access;
    const char*	sig;
    lock_set    ls;		// must be last element
} access_info_min;
*/

typedef struct access_info_t {
	int			thread;
	AccessType	access;
	const char*	sig;
	int			phase;
} access_info;

typedef struct access_info_full_t {
	addr_interval mem;
	access_info	ai;
	lock_sorted ls;
} access_info_full;

#define is_weaker_accesstype(a1,a2)	\
	((a1) == WRITE || (a2) == READ)
#define is_weaker_thread(t1,t2) \
	((t1) == MULTIPLE_THREADS || (t1) == (t2))
#define is_weaker_access(a1,a2)	\
			(is_weaker_accesstype((a1).access,(a2).access)\
			&& is_weaker_thread((a1).thread,(a2).thread))

#define is_racing_access(a1,a2)	\
			(((a1).access == WRITE || (a2).access == WRITE )\
			&& ((a1).thread != (a2).thread || (a1).thread == MULTIPLE_THREADS))

#endif /* ACCESS_H_ */
