/*
 * allocator.h
 *
 *  Created on: Apr 11, 2011
 *      Author: parkcs
 */

#ifndef ALLOCATOR_H_
#define ALLOCATOR_H_

#include <stdint.h>
#include <stdlib.h>

#define INIT_BLOCK_SIZE	4*1024*1024	// 4 MB
#define MAX_BLOCK_SIZE	256*1024*1024	// 256 MB
#define ALIGNMENT	8               // Must be a power of 2

typedef struct _memory_pool_t {
    char* heap;
    struct _memory_pool_t* prev_pool;
    size_t top;
    size_t /* const */ limit;
} memory_pool;

void new_mempool(memory_pool*);
//void free_mempool(memory_pool*);
void recycle_mempool(memory_pool*);
char* allocate(memory_pool*, size_t);
void out_of_memory_exit(const char* file, int line, size_t bytes);

#define out_of_memory(b)	out_of_memory_exit(__FILE__,__LINE__,b)

#endif /* ALLOCATOR_H_ */
