#ifndef SET_COMMON_H
#define SET_COMMON_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>
#include "../allocator.h"

#define POOL_OFFSET	(64)
#define POOL_SIZE	(POOL_OFFSET-1)	// must be 2^n - 1
#define CELLAR_SIZE (11)

#define TRUE	1
#define FALSE	0

#define set_bit(bs,i)	((bs) |= (1LL << i))
#define unset_bit(bs,i)	((bs) &= ~(1LL << i))
#define isset_bit(bs,i)	((bs) & (1LL << i))
#define more_bits(bs)	isset_bit(bs, POOL_SIZE)
#define set_more_bit(bs)	set_bit(bs, POOL_SIZE)
#define byte_index(idx)	((idx) >> 6)
#define bit_index(idx)	((idx) & POOL_SIZE)
#define data_bits(bs)	((bs) & INT64_MAX)

#include "tools.h"


typedef struct pool_ht_item_t {
    int8_t index;
    int8_t link;
} pool_ht_item;

enum iterator_state {
	INIT,
	NEXT,
	HASNEXT,
	END
};

char NEXT_INDEX[256] = {
		8, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0,
		4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0,
		5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0,
		4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0,
		6, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0,
		4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0,
		5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0,
		4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0,
		7, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0,
		4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0,
		5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0,
		4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0,
		6, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0,
		4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0,
		5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0,
		4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0
};


#endif
