/* 
 * File:   hash.h
 * Author: parkcs
 *
 * Created on June 22, 2011, 3:24 PM
 */

#ifndef HASH_H
#define	HASH_H

#define FNV_32_INIT     (2166136261)
#define FNV_32_PRIME    (16777619)

#define FNV_32_1B(h,x)  (((h) ^ ((x) & 0xff)) * FNV_32_PRIME)
#define FNV_32_2B(h,x)  FNV_32_1B(FNV_32_1B((h), (x) >> 8), x)
#define FNV_32_4B(h,x)  FNV_32_2B(FNV_32_2B((h), (x) >> 16), x)
#define FNV_32_8B(h,x)  FNV_32_4B(FNV_32_4B((h), (x) >> 32), x)

#define FNV_32_long(x)          FNV_32_4B(FNV_32_INIT, x)
#define FNV_32_longlong(x)      FNV_32_8B(FNV_32_INIT, x)

#endif	/* HASH_H */

