/* "Unit test" for addr_interval_skiplist implementation
 * Author: parkcs
 * Created on: Jun 15, 2011 
 */
#define NO_UPC

#include "addr_interval_skiplist.c"
#include "addr_skiplist.c"
#include "interval_set.c"
#include "../allocator.c"

/*
#define COUNT   17

ivl test[17] = {{{0x3ff6040, 0x3ff6048}, NULL},
                {{0x3ff6048-0x3ff6050}, NULL},
                {{0x403ff6040-0x403ff6048}, NULL},
                {{0x403ff6048-0x403ff6050}, NULL},
                {{0x403ff6050-0x403ff6058}, NULL},
                {{0x403ff6058-0x403ff6060}, NULL},
                {{0x403ff6060-0x403ff6068}, NULL},
                {{0x803ff6040-0x803ff6048}, NULL},
                {{0x803ff6048-0x803ff6050}, NULL},
                {{0x803ff6050-0x803ff6058}, NULL},
                {{0x803ff6058-0x803ff6060}, NULL},
                {{0x803ff6060-0x803ff6068}, NULL},
                {{0x803ff6068-0x803ff6070}, NULL},
                {{0x803ff6070-0x803ff6078}, NULL},
                {{0xc03ff6040-0xc03ff6048}, NULL},
                {{0xc03ff6048-0xc03ff6050}, NULL},
                {{0xc03ff6050-0xc03ff6058}, NULL}};
*/

#include "aislist_test.in"

int main()
{
    memory_pool mp;
    new_mempool(&mp); 
    addr_islist* ais = new_addr_islist(&mp);
    int i;
    ivl all = {{0x1, 0xfffffffff}, NULL};
    
    addr_islist_insert(&mp, ais, &all);
    for (i = 0; i < COUNT; ++i) {
        pivl_iter it;
        pivl_set* s = addr_islist_overlap_point(&mp, ais, test[i].range.start);
        pivl_set* e = addr_islist_overlap_point(&mp, ais, test[i].range.end);
        pivl_set* iv = addr_islist_overlap_interval(&mp, ais, &(test[i].range));
        pivl_iter_init(&it, ais->interval_pool, s);
        while(pivl_iter_hasnext(&it)) {
            pivl o = pivl_iter_next(&it);
            if (o == NULL) {
                printf("[%d] Offending set with size %d: ", i, pivl_set_elems(s));
                pivl_set_print(ais->interval_pool, s); 
                printf(" index = %d\n", it.index);
                pivl_pool_print(ais->interval_pool);
                exit(1);
            }
            // contains_interval(o->range, test[i].range);
        }
        pivl_iter_init(&it, ais->interval_pool, e);
        while(pivl_iter_hasnext(&it)) {
            pivl o = pivl_iter_next(&it);
            if (o == NULL) {
                printf("[%d] Offending set with size %d: ", i, pivl_set_elems(e));
                pivl_set_print(ais->interval_pool, e); 
                printf("\n");
                exit(1);
            }
            // contains_interval(o->range, test[i].range);
        }
        pivl_iter_init(&it, ais->interval_pool, iv);
        while(pivl_iter_hasnext(&it)) {
            pivl o = pivl_iter_next(&it);
            if (o == NULL) {
                printf("[%d] Offending set with size %d: ", i, pivl_set_elems(iv));
                pivl_set_print(ais->interval_pool, iv); 
                printf("\n");
                exit(1);
            }
            // contains_interval(o->range, test[i].range);
        }
        printf("<%d, %d, %d>\n", pivl_set_elems(s), pivl_set_elems(e),
                pivl_set_elems(iv));
        addr_islist_insert(&mp, ais, test+i);
        //addr_islist_print(ais);
    }
    addr_islist_print(ais);
 
    return 0;
}
