/*
 * interval_set.c
 *
 *  Created on: Sep 20, 2010
 *      Author: parkcs
 *
 *  Implementation for efficient operations on a set of intervals
 *  Operations include O(log n) add/remove/search and O(n) full traversal
 *
 */

#include "interval_set.h"

int pivl_hash(ivl* i)
{
	return i->range.start*2654435761 ^ i->range.end;
}

int pivl_eq(ivl* i1, ivl* i2)
{
	return (i1->range.start == i2->range.start) &&
			(i1->range.end == i2->range.end);
}

#ifndef PRIx64
#       define PRIx64 "llx"
#endif

void pivl_print(ivl* i)
{
    if (i)
	printf("[0x%" PRIx64 ",0x%" PRIx64 ")", i->range.start, i->range.end);
    else
        printf("NULL");
}
