/*
 * interval_set.h
 *
 *  Created on: Sep 20, 2010
 *      Author: parkcs
 */

#ifndef INTERVAL_SET_H_
#define INTERVAL_SET_H_

#include <stdint.h>
#include "interval.h"

typedef struct ivl_t {
	addr_interval		range;
	struct race_trie_node_t*	trie;
} ivl;

int pivl_hash(ivl* i);
int pivl_eq(ivl* i1, ivl* i2);
void pivl_print(ivl* i);

typedef ivl* pivl;
#define DATATYPE	pivl
#define HASH_FN		pivl_hash
#define DATA_EQ_FN	pivl_eq
#define DATA_PRINT_FN	pivl_print
#include "../defs/set.def"

pivl_set* pivl_set_addall(memory_pool*, pivl_set* dst, const pivl_set* src);



#if 0
uint64_t interval_set_hashcode(interval_set* s);
BOOL interval_set_add(interval_set* s, addr_interval* i);
BOOL interval_set_addall(interval_set* s, interval_set* is);
BOOL interval_set_remove(interval_set* s, addr_interval* i);
interval_set* new_interval_set();
void delete_interval_set(interval_set* s);
int interval_set_size(interval_set* s);
void interval_printer(addr_interval* i);
void interval_set_printer(interval_set* s);
#endif



#endif /* INTERVAL_SET_H_ */
