/*
 * lockset.h
 *
 *  Created on: Oct 11, 2010
 *      Author: parkcs
 */

#ifndef LOCKSET_H_
#define LOCKSET_H_

#include <stdint.h>
#include "../allocator.h"

typedef uint64_t	lock;
#define lock_hash(x)	((((x) ^ ((x) >> 32))*2654435761))
#define lock_eq(x,y)	((x) == (y))

void lock_print(const lock l);
int lock_comp(const void*, const void*);

#define DATATYPE	lock
#define HASH_FN		lock_hash
#define DATA_EQ_FN	lock_eq
#define DATA_COMP_FN	lock_comp
#define DATA_PRINT_FN	lock_print
#include "../defs/set.def"

/* Custom types and functions for locks below */

typedef struct {
	int length;
	lock* data;
} lock_pool_simple;

void lock_sorted_from_simple(memory_pool*, lock_sorted*,
        const lock_pool_simple*, const lock_set*);
void lock_sorted_print(const lock_sorted*);

#endif /* LOCKSET_H_ */
