/*
 * race_trie.h
 *
 *  Created on: Nov 3, 2010
 *      Author: parkcs
 */

#ifndef RACE_TRIE_H_
#define RACE_TRIE_H_

#include "access.h"

typedef struct race_trie_node_t race_trie_node;
typedef struct trie_ch_node_t trie_ch_node;


struct trie_ch_node_t {
	lock 			lock;
	trie_ch_node*	next;
	race_trie_node*	node;
};

struct race_trie_node_t {
	struct access_info_t*	data;
	trie_ch_node*		children;
};

race_trie_node* race_trie_new(memory_pool*);
void race_trie_free(race_trie_node*);
race_trie_node* race_trie_create(memory_pool*, lock_sorted* ls, access_info* ai);
void race_trie_add(race_trie_node*, lock_sorted*, int, access_info*);

access_info* race_trie_check_weaker(race_trie_node* node, access_info_full* acc);
access_info* race_trie_check_race(race_trie_node* node, access_info_full* acc);
void race_trie_merge(memory_pool*, race_trie_node* node, access_info_full* acc);
void race_trie_remove_stronger(race_trie_node* node, access_info_full* acc);


#endif /* RACE_TRIE_H_ */
