/* hello.upc
 * Authors - Chang-Seo Park (parkcs@cs.berkeley.edu)
 *         - Nick Jalbert   (jalbert@cs.berkeley.edu)
 *
 * Basic read/write behavior for initial version of THRILLE-UPC
 */

#include <upc.h>

#pragma relaxed
shared int sum = 0;
shared int more_sum = 0;

int main(int argc, char* argv[])
{
    int local_var = MYTHREAD;
    upc_lock_t* the_lock = upc_all_lock_alloc();
    upc_lock_t* another_lock = upc_all_lock_alloc();

    local_var *= local_var;
    printf("Local squared = %d\n", local_var);
    if (MYTHREAD == 0) {
        upc_lock(another_lock);
        upc_lock(the_lock);
        sum += local_var;
        upc_unlock(the_lock);
        upc_unlock(another_lock);
    } else {
        upc_lock(the_lock);
        more_sum += 1;
        sum += local_var;
        upc_unlock(the_lock);
    }

    if(MYTHREAD == 3) {
        upc_lock(another_lock);
        printf("Shared sum = %d\n", sum);
        upc_unlock(another_lock);
    }

    upc_barrier;

    if(MYTHREAD == 0) {
        upc_lock(another_lock);
        upc_unlock(another_lock);
        upc_lock_free(the_lock);
        upc_lock_free(another_lock);
    }

    upc_barrier;
    return 0;
}


